package com.sd.business.entity.order.enums;

import com.ruoyi.common.exception.ServiceException;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * 订单状态
 */
@Getter
@AllArgsConstructor
public enum OrderStatusEnum {
    DRAFT(0, "草稿"),
    UNDER_REVIEW(10, "订单待确认"),
    STOCK_PREPARATION(15, "备料中"),
    REJECT(20, "生产中"),
    PASS(30, "已发货"),
    COMPLETE(40, "生产完成"),
    SHIPPED(50, "退款中"),
    COMPLETED(60, "已退款"),
    INVALID(70, "订单无效"),
    DELETE(80, "订单删除审核中"),
    EXCEPTION(90, "订单异常");

    private static final Map<Integer, OrderStatusEnum> map = new HashMap<>();

    static {
        for (OrderStatusEnum orderStatusEnum : values()) {
            map.put(orderStatusEnum.getKey(), orderStatusEnum);
        }
    }

    private final Integer key;
    private final String value;

    /**
     * 通过key获取名称
     */
    public static OrderStatusEnum getEnum(Integer key) {
        OrderStatusEnum orderStatusEnum = map.get(key);
        if (orderStatusEnum == null) {
            throw new ServiceException("未知订单状态：" + key);
        }
        return orderStatusEnum;
    }

}
